#ifndef PLAYERS_HPP_INCLUDED
#define PLAYERS_HPP_INCLUDED

#include "../../Game/Interactable/Player.hpp"
#include <functional>
#include <cstdint>
#include <vector>
#include <string>

/** @addtogroup Models
* @{ */
class Players
{
    public:

        static Interactable::Player GetLocal();
        static std::vector<Interactable::Player> GetAllWithin(std::int32_t Distance);

        static std::vector<Interactable::Player> GetAll();
        static std::vector<Interactable::Player> GetAll(const Tile& Tile);
        static std::vector<Interactable::Player> GetAll(const std::string& Name, std::int32_t Distance = -1);
        static std::vector<Interactable::Player> GetAll(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static std::vector<Interactable::Player> GetAll(const std::function<bool (Interactable::Player&)>& Filter, std::int32_t Distance = -1);

        static Interactable::Player Get(const Tile& Tile);
        static Interactable::Player Get(const std::string& Name, std::int32_t Distance = -1);
        static Interactable::Player Get(const std::vector<std::string>& Names, std::int32_t Distance = -1);
        static Interactable::Player Get(const std::function<bool (const Interactable::Player&)>& Filter, std::int32_t Distance = -1);
};

/** @} */

#endif // PLAYERS_HPP_INCLUDED
